﻿namespace ProducerConsumerGeneric
{
    /// <summary>
    /// Factory producing objects of type T
    /// </summary>
    /// <typeparam name="T">the type of objects produced by this factory</typeparam>
    public interface IElementFactory<out T>
    {
        /// <summary>
        /// Returns an object of type T. 
        /// </summary>
        /// <param name="index">A number. Can be used in the creation of the returned object</param>
        /// <returns>an object of type T</returns>
        T GetElement(int index);
    }
}
