﻿using System;
using System.Globalization;

namespace ProducerConsumerGeneric
{
    /// <summary>
    /// Factory producing String objects.<br />
    /// Uses singleton design pattern
    /// </summary>
    public class StringFactory : IElementFactory<String>
    {
        private static readonly IElementFactory<String> TheInstance = new StringFactory();

        public static IElementFactory<String> Instance
        {
            get { return TheInstance;  }
        }

        private StringFactory() { }

        public string GetElement(int i)
        {
            // http://www.dotnetperls.com/tostring
            // InvariantInfo: Does not vary with social culture
            return i.ToString(NumberFormatInfo.InvariantInfo);
        }
    }
}
